
#property copyright "Breack_Out"
#property link      "https://www.mql5.com/ru/users/mqldiligent"
#property version   "1.00"
#property strict

extern string           TimeStart        = "08:05";    //   
extern string           TimeStop         = "15:05";    //   
extern double           Coeff            = 1;          // 

 int              StopLoss         = 20;         //  
 int              TakeProfit       = 35;        //  
extern double           Lot             = 0.01;       // 
 int              Otstup         = 5;         // 
 int              Min_channal  = 10;          // 
 int              Max_channal  = 100;          // 
extern int              MA_Period           = 30;       //  
 int              MA_Otstup           = 15;       //    

extern int              Magic            = 2233232;      // 

ENUM_TIMEFRAMES  Timeframe1       = PERIOD_H4;  //  

int ticket, Slippage = 5;
double SL, TP, UR_Up, UR_Down, UR_Buy, UR_Sell;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   if (Digits == 5 || (Digits == 3 && StringFind(Symbol(), "JPY") != -1))
   {
      Otstup      *= 10;
      StopLoss        *= 10;
      TakeProfit      *= 10;
      Slippage        *= 10;
      Min_channal      *= 10;
      Max_channal      *= 10;
      MA_Otstup      *= 10;

   }
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
   
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{  
   
 
   if (TimeCurrent() == StrToTime(TimeStart))
   {
   UR_Up = iHigh(NULL,PERIOD_H4,1);
   UR_Down = iLow(NULL,PERIOD_H4,1);
   UR_Buy = UR_Up + Otstup*Point;
   UR_Sell = UR_Down - Otstup*Point;
   ticket = 0;
   }
   if ( TimeCurrent() == StrToTime(TimeStart))
   {
      double atr = iATR(_Symbol, Timeframe1, 6, 1) / _Point;
      if (atr < 100) atr = 100;
      if (atr > 1000) atr = 1000;
      
      Min_channal = atr * 0.5 * Coeff;
      Max_channal = atr * Coeff;
      Otstup = atr * 0.25 * Coeff;
      MA_Otstup = atr * 0.5 * Coeff;
      StopLoss = atr * Coeff;
      TakeProfit = atr * 1.5 * Coeff;
      
   
      if (ticket == 0) 
      {
      if (SignalBuy())
      {
         
         SL = NormalizeDouble(UR_Buy-StopLoss*Point, Digits); if (StopLoss == 0) SL = 0;
         TP = NormalizeDouble(UR_Buy+TakeProfit*Point, Digits); if (TakeProfit == 0) TP = 0;
         ticket = OrderSend(Symbol(), OP_BUYSTOP, Lot, UR_Buy, Slippage, SL, TP, "Breack_Out", Magic);
         
      }
            if (SignalSell())
      {
         UR_Sell = UR_Down - Otstup*Point;
         SL = NormalizeDouble(UR_Sell+StopLoss*Point, Digits); if (StopLoss == 0) SL = 0;
         TP = NormalizeDouble(UR_Sell-TakeProfit*Point, Digits); if (TakeProfit == 0) TP = 0;
         ticket = OrderSend(Symbol(), OP_SELLSTOP, Lot, UR_Down, Slippage, SL, TP, "Breack_Out", Magic);
         
      }
     } 
   }
   
   if (TimeCurrent() == StrToTime(TimeStop)) Order_Close();
   
  
   
   
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
bool SignalBuy()
{

   
   if ((UR_Up - UR_Down)> Min_channal*Point && (UR_Up - UR_Down)< Max_channal*Point && (UR_Down - iMA(NULL, Timeframe1,MA_Period,0,MODE_SMA,PRICE_MEDIAN,1)) > MA_Otstup*Point) return(true);
   
   return(false);
}
//+------------------------------------------------------------------+
bool SignalSell()
{
   
   if ((UR_Up - UR_Down)> Min_channal*Point && (UR_Up - UR_Down)< Max_channal*Point && (iMA(NULL, Timeframe1,MA_Period,0,MODE_SMA,PRICE_MEDIAN,1) - UR_Up) > MA_Otstup*Point) return(true);
   
   return(false);
}
//+------------------------------------------------------------------+
void Order_Close()
{
  for(int i=0; i<=OrdersTotal(); i++)          //   
  {
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true) //   
        {                                       //  :
          if (OrderSymbol()!=Symbol())continue;      //   . 
          if (OrderMagicNumber()!=Magic)continue;  
          int Ticket=OrderTicket();
          if (OrderType() != OP_BUY || OrderType() != OP_SELL ) 
          {
          int n=0;
          while(true)
          {
           if ( OrderDelete(Ticket) == true ) break;
           n++;
           if (n >=10 ) 
            {
             if ( GetLastError() != 0  )  Alert("   ",Ticket,"      10,  ");            
            break;
            }
          }
          }
        }
    }

}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
